#!/bin/bash

set -euo pipefail

MAILCOW_TMP_DIR="$(mktemp --directory)"
export MAILCOW_BACKUP_LOCATION="${MAILCOW_TMP_DIR:?}/backup"
mkdir --parent --mode=777 "${MAILCOW_BACKUP_LOCATION}"
export RESTIC_REPOSITORY="sftp://u301712@u301712.your-storagebox.de/mailcow"
RESTIC_SFTP_COMMAND_OPTION="-o sftp.command=ssh -i /root/.ssh/id_storagebox -p 23 u301712@u301712.your-storagebox.de -s sftp"
export RESTIC_PASSWORD='{{ lookup('passwordstore', env +'/mailserver/RESTIC_PASSWORD create=true')}}'
if ([ -z "$(restic "${RESTIC_SFTP_COMMAND_OPTION}" cat config)" ]) 2>/dev/null; then
  restic "${RESTIC_SFTP_COMMAND_OPTION}" init --repo="${RESTIC_REPOSITORY}"
fi
/opt/mailcow/git_config/helper-scripts/backup_and_restore.sh backup all
restic "${RESTIC_SFTP_COMMAND_OPTION}" backup "${MAILCOW_BACKUP_LOCATION}"
rm --recursive --force "${MAILCOW_TMP_DIR:?}"

# Some maintenance to keep the repo clean
restic "${RESTIC_SFTP_COMMAND_OPTION}" forget --group-by host --prune --keep-hourly 24 --keep-daily 7 --keep-weekly 4
